/*
 * @File: batchExecutor.js
 * @Description: 批量执行pgsql数据插入脚本
 * @Author: clownce.deng
 * @Date: 2020-05-13 14:48:00
 */

var _ = require("lodash");
var fs = require("fs");
var moment = require("moment");
var logger = require("topsin.logger");
var DB = require("topsin.database");
var error = require("topsin.error");
var console = require("console");
var process = require('process');
var ioprocess = require('topsin.ioprocess');
var config = require("./config");

try {
    var argv = process.argv;
    // 脚本选择  0:batchInsert脚本，1:COPY脚本
    var type = _.toNumber(argv[1]);
    // 进程数量
    var process_count = _.toNumber(argv[2]);
    // 插入数据行数
    var data_row_count = _.toNumber(argv[3]);
    if (_.isNaN(type) || _.isNaN(process_count) || _.isNaN(data_row_count) || process_count == 0 || data_row_count == 0) {
        throw "invalid parameter.";
    }
    var script_name = "";
    if (type == 0)  {
        script_name = "./pgBatchInsert.js";
    } else if (type == 1) {
        script_name = "./pgBatchCopy.js";
    } else {
        throw "invalid parameter: " + type;
    }
    for (var count = 1; count <= process_count; count++) {
        var ret = ioprocess.startDetached(config.topjs_path, [script_name, count, data_row_count]);
        console.info("Process " + count + " result: " + ret);
    }

} catch (e) {
    console.error(e);
}